Subject: [PATCH 0/8] GIT_TEST_PROTOCOL_VERSION, this time on master

From: Jonathan Tan <[email-masked]>
Date: Mon, 25 Feb 2019 13:54:05 -0800

There's a version of this in Junio's Git repository as
jt/test-protocol-version, blocked by js/protocol-advertise-multi. After
chatting with Josh (the author of js/protocol-advertise-multi) last
week, it seems that that branch might take a while, so I have decided to
rebase my patches on master.

This necessitates patch 2, which contains additional updates to t5601,
so that all tests pass with GIT_TEST_PROTOCOL_VERSION=1.
(js/protocol-advertise-multi eliminates the need to do that, which is
why these changes did not appear in the previous version.) When
js/protocol-advertise-multi is merged, we can and should revert patch 2.

I have incorporated a small suggestion by Peff [1], and he seems overall
OK with the patch set [2].

I have based my work on the existing contents of
jt/test-protocol-version, so most commits include a "Signed-off-by" line by
Junio. Let me know if you prefer it to be removed.

[1] https://public-inbox.org/git/[email-masked]/
[2] https://public-inbox.org/git/[email-masked]/

Here is a range-diff.

1:  7ed58eb98b ! 1:  4dcd898813 tests: define GIT_TEST_PROTOCOL_VERSION
    @@ -8,9 +8,8 @@
         configuration is in place for all repositories.
     
         As of this patch, all tests pass whether GIT_TEST_PROTOCOL_VERSION is
    -    unset, set to 0, or set to 1. Some tests fail when
    -    GIT_TEST_PROTOCOL_VERSION is set to 2, but this will be dealt with in
    -    subsequent patches.
    +    unset or set to 0. Some tests fail when GIT_TEST_PROTOCOL_VERSION is set
    +    to 1 or 2, but this will be dealt with in subsequent patches.
     
         This is based on work by Ævar Arnfjörð Bjarmason.
     
    @@ -39,7 +38,7 @@
     +		retval = version;
     +	}
     +
    -+	if (git_test_v && strlen(git_test_v)) {
    ++	if (git_test_v && *git_test_v) {
     +		enum protocol_version env = parse_protocol_version(git_test_v);
     +
     +		if (env == protocol_unknown_version)
    @@ -52,7 +51,7 @@
     +	return retval;
      }
      
    - void register_allowed_protocol_version(enum protocol_version version)
    + enum protocol_version determine_protocol_version_server(void)
     
      diff --git a/t/README b/t/README
      --- a/t/README
-:  ---------- > 2:  1c865e4ae9 t5601: check ssh command only with protocol v0
2:  1b3c299528 = 3:  227a88aa8c tests: always test fetch of unreachable with v0
3:  526670b1d5 = 4:  8f510c5c78 t5503: fix overspecification of trace expectation
4:  1548be81a5 = 5:  9aaabdac52 t5512: compensate for v0 only sending HEAD symrefs
5:  1da961b33a = 6:  6c29e64bc3 t5700: only run with protocol version 1
6:  3c22aaad5b = 7:  d4638e9418 tests: fix protocol version for overspecifications
7:  188754ca3f = 8:  629a243c7f t5552: compensate for v2 filtering ref adv.

Jonathan Tan (8):
  tests: define GIT_TEST_PROTOCOL_VERSION
  t5601: check ssh command only with protocol v0
  tests: always test fetch of unreachable with v0
  t5503: fix overspecification of trace expectation
  t5512: compensate for v0 only sending HEAD symrefs
  t5700: only run with protocol version 1
  tests: fix protocol version for overspecifications
  t5552: compensate for v2 filtering ref adv.

 protocol.c                           | 17 ++++++++--
 t/README                             |  3 ++
 t/t5400-send-pack.sh                 |  2 +-
 t/t5500-fetch-pack.sh                |  4 ++-
 t/t5503-tagfollow.sh                 |  2 +-
 t/t5512-ls-remote.sh                 | 18 ++++++++---
 t/t5515-fetch-merge-logic.sh         |  4 +++
 t/t5516-fetch-push.sh                | 22 ++++++++++---
 t/t5539-fetch-http-shallow.sh        |  5 ++-
 t/t5541-http-push-smart.sh           | 14 +++++++--
 t/t5551-http-fetch-smart.sh          | 47 +++++++++++++++++++++-------
 t/t5552-skipping-fetch-negotiator.sh |  5 ++-
 t/t5601-clone.sh                     | 16 +++++-----
 t/t5700-protocol-v1.sh               |  3 ++
 t/t7406-submodule-update.sh          |  5 ++-
 15 files changed, 128 insertions(+), 39 deletions(-)

-- 
2.19.0.271.gfe8321ec05.dirty